import gtk


def ProgrammBeenden(sagtJemand):
  # Diese Funktion wird aufgerufen, wenn jemand den Beenden-Knopf drueckt
  gtk.main_quit()

def berechnen(sagtJemand):
  # Diese Funktion wird aufgerufen, wenn jemand den Berechnen-Knopf drueckt.
  # Sie liest Gewicht und Groesse aus dem Fenster aus, berechnet den BMI,
  # und schreibt den dann wieder ins Fenster.
  
  # Erstmal das Gewicht holen und in eine Zahl umwandeln.
  gewicht = gewichtEingabe.get_text()
  gewichtAlsZahl = float(gewicht)
  
  # Jetzt die Groesse holen und in eine Zahl umwandeln.
  # Die Groesse muss durch 100 geteilt werden, weil der Benutzer sie in cm
  # eingibt, wir fuer die Formel aber die Groesse in Metern brauchen.
  groesse = groesseEingabe.get_text()
  groesseAlsZahl = float(groesse) / 100
  
  # Die eigentliche Berechnung:
  bmi = gewichtAlsZahl / (groesseAlsZahl * groesseAlsZahl)
  
  # Den fertig berechneten BMI in das BMItext-Objekt unseres Fensters schreiben:
  BMItext.set_text("Dein BMI ist " + str(bmi) + ".")


# Wir brauchen ein Hauptfenster:
meinFenster = gtk.Window()

# Unser Programmfenster soll aus mehreren Zeilen von Buttons
# und anderen Elementen bestehen
untereinander = gtk.VBox()
untereinander.show()
meinFenster.add(untereinander)


# Erste Zeile: Hier soll der Benutzer sein Gewicht eingeben
zeileGewicht = gtk.HBox()
zeileGewicht.show()
untereinander.pack_start(zeileGewicht)

gewichtText = gtk.Label("Gewicht in kg: ") # Erklaerungstext
gewichtText.show()
zeileGewicht.pack_start(gewichtText)

gewichtEingabe = gtk.Entry() # Eingabefeld
gewichtEingabe.show()
zeileGewicht.pack_start(gewichtEingabe)


# Zweite Zeile: Hier soll der Benutzer seine Groesse eingeben
zeileGroesse = gtk.HBox()
zeileGroesse.show()
untereinander.pack_start(zeileGroesse)

groesseText = gtk.Label("Groesse in cm: ") # Erklaerungstext
groesseText.show()
zeileGroesse.pack_start(groesseText)

groesseEingabe = gtk.Entry() # Eingabefeld
groesseEingabe.show()
zeileGroesse.pack_start(groesseEingabe)


# Dritte Zeile: Hier soll spaeter das Ergebnis stehen,
# am Anfang nur ein Infotext
BMItext = gtk.Label("Klicke unten, um deinen BMI auszurechnen.")
BMItext.show()
untereinander.pack_start(BMItext)
# Diese "Zeile" besteht nur aus einem Text, nur aus einem Objekt!


# Vierte Zeile: Der Berechnen-Button
buttonBerechnen = gtk.Button("Berechnen!")
buttonBerechnen.show()
untereinander.pack_start(buttonBerechnen)
buttonBerechnen.connect("clicked", berechnen) # Button seine Funktion geben


# Fuenfte Zeile: Der Ende-Button
buttonBeenden = gtk.Button("Ende")
pinkefarbe = gtk.gdk.Color(65535, 0, 65535)
buttonBeenden.modify_bg(gtk.STATE_NORMAL, pinkefarbe)
buttonBeenden.show()
untereinander.pack_start(buttonBeenden)
buttonBeenden.connect("clicked", ProgrammBeenden) # Button seine Funktion geben

# Fenster Anzeigen und Programmkontrolle an GTK abgeben
meinFenster.show()
gtk.main()
